/*
 * Copyright (c) 2007, Laminar Research.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 */

#ifndef GUI_PACKER_H
#define GUI_PACKER_H

#include "GUI_Pane.h"

enum GUI_Packer_Side {
	gui_Pack_Left,
	gui_Pack_Right,
	gui_Pack_Bottom,
	gui_Pack_Top,
	gui_Pack_Center
};


class	GUI_Packer : public GUI_Pane {
public:

			 GUI_Packer();
	virtual	~GUI_Packer();

			void		PackPane(GUI_Pane * child, GUI_Packer_Side);
			void		PackPaneToRight(GUI_Pane * child, GUI_Packer_Side side, GUI_Pane * target);
	virtual void		SetBounds(int x1, int y1, int x2, int y2);
	virtual void		SetBounds(int inBounds[4]);
	virtual	void		Draw(GUI_GraphState * state);
	
			void		SetBkgkndImage(const char * image_res);
		
private:

	string	mImage;
	int		mPackArea[4];

};


#endif /* GUI_PACKER_H */