/*
 * Copyright (c) 2007, Laminar Research.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 */

#ifndef WED_SEALANE_H
#define WED_SEALANE_H

#include "WED_GISLine_Width.h"

struct	AptSealane_t;

class	WED_Sealane : public WED_GISLine_Width {

DECLARE_PERSISTENT(WED_Sealane)

public:

	void		SetBuoys(int);
	int			GetBuoys(void) const { return buoys.value; }

	void		Import(const AptSealane_t& x, void (* print_func)(void *, const char *, ...), void * ref);
	void		Export(		 AptSealane_t& x) const;

	virtual const char *	HumanReadableType(void) const { return "Sea Lane"; }

private:

	WED_PropBoolText		buoys;

};

#endif /* WED_SEALANE_H */
